Subject: Re: linux-next: build failure after merge of the usb tree

From: Andy Shevchenko <[email-masked]>
Date: Wed, 30 Nov 2022 12:58:43 +0200

On Wed, Nov 30, 2022 at 11:52:05AM +0100, Greg KH wrote:
> On Wed, Nov 30, 2022 at 01:18:54PM +1100, Stephen Rothwell wrote:
> > Hi all,
> > 
> > After merging the usb tree, today's linux-next build (x86_64 allmodconfig)
> > failed like this:
> > 
> > drivers/xen/unpopulated-alloc.c:17:21: error: 'list_count' redeclared as different kind of symbol
> >    17 | static unsigned int list_count;
> >       |                     ^~~~~~~~~~
> > In file included from include/linux/preempt.h:11,
> >                  from include/linux/spinlock.h:56,
> >                  from include/linux/mmzone.h:8,
> >                  from include/linux/gfp.h:7,
> >                  from drivers/xen/unpopulated-alloc.c:3:
> > include/linux/list.h:662:22: note: previous definition of 'list_count' with type 'size_t(struct list_head *)' {aka 'long unsigned int(struct list_head *)'}
> >   662 | static inline size_t list_count(struct list_head *head)
> >       |                      ^~~~~~~~~~
> > 
> > Caused by commit
> > 
> >   a9efc04cfd05 ("i915: Move list_count() to list.h for broader use")
> > 
> > I have used the usb tree from next-20221129 for today.
> 
> Odd, there is also one in the z2ram.c code but that isn't breaking :(
> 
> Andy, I'm going to revert this series from the USB tree now, please fix
> it up and resend.

Sure. I think I will rename in my series list_count() to list_count_nodes().
This will be less invasive and should solve the issue(s).

$ git grep -n -lw list_count
drivers/block/z2ram.c
drivers/gpu/drm/i915/gt/intel_engine_cs.c
drivers/scsi/hptiop.c
drivers/scsi/hptiop.h
drivers/xen/unpopulated-alloc.c

$ git grep -n -lw list_count_nodes

-- 
With Best Regards,
Andy Shevchenko